/* license: AGPLv3 or later */
/* copyright 2024 zamfofex */

#include "../mimimi.h"

void mimimi_stamp(struct mimimi_image *target, int x1, int y1, struct mimimi_image *source)
{
	int x, y;
	int x0, y0;
	int x2, y2;
	int width, height;
	unsigned char color;
	
	x0 = 0;
	y0 = 0;
	
	if (x1 < 0) x0 = -x1;
	if (y1 < 0) y0 = -y1;
	
	width = source->width;
	height = source->height;
	
	if (width + x1 > target->width) width = target->width - x1;
	if (height + y1 > target->height) height = target->height - y1;
	
	for (y = y0 ; y < height ; y++) {
		for (x = x0 ; x < width ; x++) {
			color = source->colors[x + y * source->width];
			if (color == 0) continue;
			x2 = x + x1;
			y2 = y + y1;
			target->colors[x2 + y2 * target->width] = color;
		}
	}
}
