/* license: AGPLv3 or later */
/* copyright 2024 zamfofex */

#include "../mimimi.h"

void mimimi_wasm(void);

static void *mimimi_wasm_data;
static void (*mimimi_wasm_tick0)(void *data, struct mimimi_input *input);

struct mimimi_input *mimimi_wasm_tick(int left, int right, int width, int height)
{
	static struct mimimi_input input;
	input.left = left;
	input.right = right;
	input.image.width = width;
	input.image.height = height;
	(*mimimi_wasm_tick0)(mimimi_wasm_data, &input);
	return &input;
}

void mimimi_main(void (*tick)(void *data, struct mimimi_input *input), void *data)
{
	mimimi_wasm_tick0 = tick;
	mimimi_wasm_data = data;
	mimimi_wasm();
}
