# license: AGPLv3 or later
# copyright 2024 zamfofex

from mido import MidiFile
from sys import argv, stderr

repeat = 0
notes = []

for i, track in enumerate(MidiFile(argv[1]).tracks):
	index = 0
	prev = None
	for msg in track:
		if msg.is_meta: continue
		repeat += msg.time // 64
		if msg.type != "note_on" and msg.type != "note_off": continue
		if prev != None:
			length = len(notes)
			if length < index + repeat:
				for n in range(index + repeat - length): notes.append([None] * 16)
			for j in range(repeat):
				notes[index + j][i] = (prev, -1)
		index += repeat
		repeat = 0
		if msg.type == "note_off": prev = None
		else: prev = msg.note

print("{")
for tick in notes:
	print("{", end="")
	for note in tick:
		if note == None: print("{0,0},", end="")
		else: print(f"{{{note[0] * 2},{note[1]}}},", end="")
	print("},")
print("},", len(notes))
